//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern string TimeFrame             = "Current time frame";
extern bool   UseAutomaticMaPeriods = true;
extern int    MaMethod              = MODE_SMMA;
extern int    MaPeriod              = 6;

//
//
//
//
//

double hahu[];
double hahd[];
double hahbu[];
double hahbd[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,hahd);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hahu);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,hahbd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,hahbu); SetIndexStyle(3,DRAW_HISTOGRAM);
      if (UseAutomaticMaPeriods)
         switch(Period()) 
         {
            case PERIOD_M1:  MaPeriod = 150; break;
            case PERIOD_M5:  MaPeriod =  60; break;
            case PERIOD_M15: MaPeriod =  80; break;
            case PERIOD_M30: MaPeriod = 192; break;
            case PERIOD_H1:  MaPeriod =  96; break;
            case PERIOD_H4:  MaPeriod = 120; break;
            default :        MaPeriod = 80;
         }
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   
   return(0);
}   
 
//
//
//
//
//
     
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { hahu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for (i=limit; i>=0; i--)
      {
         double haHigh,haLow,haOpen,haClose;
            calculateHA(i,haOpen,haClose,haHigh,haLow);
            
            //
            //
            //
            //
            //
            
            hahu[i]  = haHigh; 
            hahd[i]  = haLow;
            hahbu[i] = haOpen;
            hahbd[i] = haClose;
      }            
      return(0);      
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         hahu[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UseAutomaticMaPeriods,MaMethod,MaPeriod,0,y);
         hahd[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UseAutomaticMaPeriods,MaMethod,MaPeriod,1,y);
         hahbu[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UseAutomaticMaPeriods,MaMethod,MaPeriod,2,y);
         hahbd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",UseAutomaticMaPeriods,MaMethod,MaPeriod,3,y);
   }
   return(0);
         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double workHa[][4];
void calculateHA(int i, double& tOpen, double& tClose, double& tHigh, double& tLow)
{
   if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); int r=Bars-i-1;
   
   //
   //
   //
   //
   //
   
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_OPEN ,i);
      double maClose = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_CLOSE,i);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_LOW  ,i);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_HIGH ,i);
      double haOpen  = (workHa[r-1][2] + workHa[r-1][3])/2.0;
      double haClose = (maOpen+maHigh+maLow+maClose)/4;
      double haHigh  = MathMax(maHigh, MathMax(haOpen, haClose));
      double haLow   = MathMin(maLow,  MathMin(haOpen, haClose));

      if(haOpen<haClose) { workHa[r][0] = haLow;  workHa[r][1] = haHigh; } 
      else               { workHa[r][0] = haHigh; workHa[r][1] = haLow;  } 
                           workHa[r][2] = haOpen;
                           workHa[r][3] = haClose;
      //
      //
      //
      //
      //
      
   tHigh  = workHa[r][0];
   tLow   = workHa[r][1];
   tOpen  = workHa[r][2];
   tClose = workHa[r][3];
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}